
import { defineStore } from "pinia";
import { ref } from "vue";
import { useTabsStore } from "@/stores/tabsStore.ts";
import { usePermissionStore } from "@/stores/permission.ts";
export const useTestStore = defineStore(
  "token",
  () => {
    const userToken = ref('');
    const  testToken =  (token:string)=>{
      userToken.value  = token
    }
    const resetUserTest = () => {
      userToken.value = ''
    };
    return {
      userToken,
      testToken,
      resetUserTest
    };
  },
  {
    persist: {
      key: "token",
      storage: localStorage,
      pick: ["userToken"],
    },
  }
);
