/// <reference types="vite/client" />
declare module "*.vue" {
  import { DefineComponent } from "vue";
  const component: DefineComponent<{}, {}, any>;
  export default component;
}
interface ImportMetaEnv {
  // 项目名称
  readonly VITE_APP_NAME: string;
  // 当前环境
  readonly VITE_APP_ENV: "development" | "production";
  // 启动端口
  readonly VITE_APP_PORT: number;

  // axios
  readonly VITE_APP_BASE_API: string;
  readonly VITE_APP_PROXY_URL: string;

  // jsencrypt
  readonly VITE_APP_JS_ENCRYPT_PUBLIC_KEY: string;
}
